/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * File Name          : app_freertos.c
  * Description        : Code for freertos applications
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2024 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Includes ------------------------------------------------------------------*/
#include "FreeRTOS.h"
#include "task.h"
#include "main.h"
#include "cmsis_os2.h"
/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "stdio.h"
#include "draw.h"
#include "stdio.h"
#include "draw.h"
#include "ux_api.h"
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */

/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
/* USER CODE BEGIN Variables */
extern UART_HandleTypeDef huart4;
extern UART_HandleTypeDef huart2;

int Wait_UART2_Tx_Complete(int timeout);
int Wait_UART4_Rx_Complete(int timeout);
int UART4_GetData(uint8_t *pData);
void UART4_Rx_Start(void);

/* USER CODE END Variables */
/* Definitions for defaultTask */
osThreadId_t defaultTaskHandle;
const osThreadAttr_t defaultTask_attributes = {
  .name = "defaultTask",
  .priority = (osPriority_t) osPriorityNormal,
  .stack_size = 128 * 4
};

/* Private function prototypes -----------------------------------------------*/
/* USER CODE BEGIN FunctionPrototypes */

static void SPILCDTaskFunction( void *pvParameters )	
{
	char buf[100];
	int cnt = 0;
	
	while (1)
	{
		sprintf(buf, "LCD Task Test : %d\r\n", cnt++);
		//Draw_String(0, 0, buf, 0x0000ff00, 0);
		int ux_device_cdc_acm_send(uint8_t *datas, uint32_t len, uint32_t timeout);
		ux_device_cdc_acm_send((uint8_t *)buf, strlen(buf), 1000);
		vTaskDelay(1000);		
	}
}

static void CH1_UART2_TxTaskFunction( void *pvParameters )	
{
	uint8_t c = 0;
	
	while (1)
	{
		/* send data */
		HAL_UART_Transmit_DMA(&huart2, &c, 1);
		Wait_UART2_Tx_Complete(100);
		vTaskDelay(500);
		c++;
	}
}

static void CH2_UART4_RxTaskFunction( void *pvParameters )	
{
	uint8_t c = 0;
	int cnt = 0;
	char buf[100];
	HAL_StatusTypeDef err;

	UART4_Rx_Start();
	
	while (1)
	{
		/* 接收数据 */
		err = UART4_GetData(&c);
		
		if (err == 0)		
		{
			sprintf(buf, "Recv Data : 0x%02x, Cnt : %d", c, cnt++);
			//Draw_String(0, 0, buf, 0x0000ff00, 0);
		}
		else
		{
			HAL_UART_DMAStop(&huart4);
		}
	}
}

/* USER CODE END FunctionPrototypes */

void StartDefaultTask(void *argument);

void MX_FREERTOS_Init(void); /* (MISRA C 2004 rule 8.1) */

/**
  * @brief  FreeRTOS initialization
  * @param  None
  * @retval None
  */
void MX_FREERTOS_Init(void) {
  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* USER CODE BEGIN RTOS_MUTEX */
  /* add mutexes, ... */
  /* USER CODE END RTOS_MUTEX */

  /* USER CODE BEGIN RTOS_SEMAPHORES */
  /* add semaphores, ... */
  /* USER CODE END RTOS_SEMAPHORES */

  /* USER CODE BEGIN RTOS_TIMERS */
  /* start timers, add new ones, ... */
  /* USER CODE END RTOS_TIMERS */

  /* USER CODE BEGIN RTOS_QUEUES */
  /* add queues, ... */
  /* USER CODE END RTOS_QUEUES */
  /* creation of defaultTask */
  defaultTaskHandle = osThreadNew(StartDefaultTask, NULL, &defaultTask_attributes);

  /* USER CODE BEGIN RTOS_THREADS */
  /* add threads, ... */
	xTaskCreate(
		SPILCDTaskFunction, // 函数指针, 任务函数
		"spi_lcd_task", // 任务的名?
		200, // 栈大?,单位为word,10表示40字节
		NULL, // 调用任务函数时传入的参数
		osPriorityNormal, // 优先?
		NULL); // 任务句柄, 以后使用它来操作这个任务

	xTaskCreate(
		CH1_UART2_TxTaskFunction,
		"ch1_uart2_tx_task",
		200,
		NULL,
		osPriorityNormal,
		NULL);

	xTaskCreate(
		CH2_UART4_RxTaskFunction,
		"ch2_uart4_rx_task",
		200,
		NULL,
		osPriorityNormal,
		NULL);

  /* USER CODE END RTOS_THREADS */

  /* USER CODE BEGIN RTOS_EVENTS */
  /* add events, ... */
  /* USER CODE END RTOS_EVENTS */

}
/* USER CODE BEGIN Header_StartDefaultTask */
/**
* @brief Function implementing the defaultTask thread.
* @param argument: Not used
* @retval None
*/
/* USER CODE END Header_StartDefaultTask */
void StartDefaultTask(void *argument)
{
  /* USER CODE BEGIN defaultTask */
  /* Infinite loop */
  for(;;)
  {
// 		HAL_GPIO_WritePin(GPIOC, GPIO_PIN_12, GPIO_PIN_RESET);
//		vTaskDelay(500);
//		
//		HAL_GPIO_WritePin(GPIOC, GPIO_PIN_12, GPIO_PIN_SET);
//		vTaskDelay(500);
	ux_system_tasks_run();
  }
  /* USER CODE END defaultTask */
}

/* Private application code --------------------------------------------------*/
/* USER CODE BEGIN Application */

/* USER CODE END Application */

